# Ayden Project Documentation

## Table of Contents

- [About Ayden Project](#about-ayden-project)
- [Installation](#installation)
- Components
  - [Warlock Kit](#component-warlock-kit)
  - [Recruitable NPC](#component-recruitable-npc)
  - [Shadow Walking](#component-shadow-walking)
  - [Random Encounters](#component-random-encounters)
  - [Ayden's Refuge](#component-aydens-refuge)
  - [Item Crafting](#component-item-crafting)
  - [Wands for Thieves](#component-wands-for-thieves)
  - [Thief Proficiencies](#component-thief-proficiencies)
- [Known Issues](#known-issues)
- [Compatibility](#compatibility)
- [Frequently Asked Questions](#frequently-asked-questions)
- [Special Thanks](#special-thanks)
- [Copyright Notice](#copyright-notice)
- [Version History](#version-history)

## About Ayden Project

Ayden is primarily a companion mod, but comes bundled with a set of additional components.

- **Warlock Kit:** Warlock is a Thief class kit based on the Warlock class from 3rd edition D&D. (BG:EE, BG:SoD)
- **Ayden NPC:** A recruitable NPC with custom dialogues, banter, and quests. (BG:EE, BG:SoD)
- **Shadow Walking:** A feature offered by the NPC to reduce travelling time. (BG:EE, BG:SoD)
- **Ayden's Refuge:** A pocket plane where the party can rest and store items. (BG:EE, BG:SoD)
- **Item Crafting:** A simple item crafting system offered in the form of a dialog with the NPC. (BG:EE, BG:SoD)
- **Wands for Thieves:** Enable the use of wands for all thief kits (including warlock). (Any)
- **Thief Proficiencies:** Enable mace and spear proficiency for all thief kits. (Any)

Ayden project is still in development. Be sure to check back once in a while to get the latest version.

## Installation

1. Make sure you have an updated version (v2.6) of Baldur's Gate: Enhanced Edition installed on your hard drive.
2. Extract the contents of the archive to your Baldur's Gate installation directory.
3. If you have BG:SoD installed you must also install the [DLC Merger](https://github.com/Argent77/A7-DlcMerger/releases) mod before anything else.
4. Run Setup-Ayden.exe and follow the instructions that appear on the console screen.
5. It is recommended that you start a new game to make full use of this mod's features.

_Example Installation Directory:_
- `(Steam version)` C:\Steam\steamapps\common\Baldur's Gate Enhanced Edition
- `(BeamDog version)` C:\Program Files (x86)\BeamDog\Games\00766
- `(Custom installation)` C:\Games\Baldur's Gate Enhanced Edition\Data

## Component: Warlock Kit

This component adds a new Thief kit called Warlock into the game.

> Warlocks are masters of the dark arts, reckless mortals who draw their power from strange and sinister entities. Unlike mages, who approach magic through the medium of spells, a warlock invokes powerful magic through nothing more than an effort of will. By harnessing his dark gift through fearsome determination, a warlock can enhance his senses, beguile the weak-minded, or scour his foes with blasts of eldritch power.

#### Advantages:

- Faster Lore progression (+6/level).
- Can use a small number of innate magical abilities.
- Becomes increasingly more powerful as his powers awaken.

#### Disadvantages:

- Has only one weapon slot.
- Cannot use thief skills other than Detect Illusions.
- Gains no inherent backstab multiplier.
- Cannot set snares.

### Table: The Warlock

| Level | Abilities | Lore | Level | Abilities | Lore |
| :---: | :-------- | :--: | :---: | :-------- | :--: |
| 1st | [*Eldritch Blast*](#eldritch-blast) (1d6), [*Devil's Sight*](#devils-sight) | 6 | 21st | [*Eldritch Blast*](#eldritch-blast) (11d6), [Energy Resistance](#energy-resistance) III | 126 |
| 2nd | [*Shadow Armor*](#shadow-armor) | 12 | 22nd | [*Devour Magic*](#devour-magic) | 132 |
| 3rd | [*Eldritch Blast*](#eldritch-blast) (2d6), [Unearthly Resilience](#unearthly-resilience) I | 18 | 23rd | [*Eldritch Blast*](#eldritch-blast) (12d6) | 138|
| 4th | [*Brimstone Ray*](#brimstone-ray) | 24 | 24th | [High-Level Abilities](#high-level-abilities) | 144|
| 5th | [*Eldritch Blast*](#eldritch-blast) (3d6), [Energy Resistance](#energy-resistance) I | 30 | 25th | [*Eldritch Blast*](#eldritch-blast) (13d6) | 150|
| 6th | [*Walk Unseen*](#walk-unseen) | 36 | 26th | |156|
| 7th | [*Eldritch Blast*](#eldritch-blast) (4d6), [Fiendish Servant](#fiendish-servant) I | 42 | 27th | [*Eldritch Blast*](#eldritch-blast) (14d6) | 162|
| 8th | [*Hellrime Breath*](#hellrime-breath) | 48 | 28th | |168|
| 9th | [*Eldritch Blast*](#eldritch-blast) (5d6) | 54 | 29th | [*Eldritch Blast*](#eldritch-blast) (15d6), [Energy Resistance](#energy-resistance) IV | 174|
| 10th | [*A Cold Day in Hell*](#a-cold-day-in-hell) | 60 | 30th | |180|
| 11th | [*Eldritch Blast*](#eldritch-blast) (6d6) | 66 | 31st | [*Eldritch Blast*](#eldritch-blast) (16d6), [Unearthly Resilience](#unearthly-resilience) III | 186|
| 12th | [*Enthrall*](#enthrall) | 72 | 32nd | |192|
| 13th | [*Eldritch Blast*](#eldritch-blast) (7d6), [Energy Resistance](#energy-resistance) II | 78 | 33rd | [*Eldritch Blast*](#eldritch-blast) (17d6) | 198|
| 14th | [*Flee the Scene*](#flee-the-scene) | 84 | 34th | |204|
| 15th | [*Eldritch Blast*](#eldritch-blast) (8d6), [Fiendish Servant](#fiendish-servant) II | 90 | 35th | [*Eldritch Blast*](#eldritch-blast) (18d6) | 210|
| 16th | [*Vitriolic Burst*](#vitriolic-burst) | 96 | 36th | |216|
| 17th | [*Eldritch Blast*](#eldritch-blast) (9d6), [Unearthly Resilience](#unearthly-resilience) II | 102 | 37th | [*Eldritch Blast*](#eldritch-blast) (19d6), [Energy Resistance](#energy-resistance) V | 222|
| 18th | [*Vomit Swarm*](#vomit-swarm) | 108 | 38th | |228|
| 19th | [*Eldritch Blast*](#eldritch-blast) (10d6) | 114 | 39th | [*Eldritch Blast*](#eldritch-blast) (20d6) | 234|
| 20th | [*Lightning Chain*](#lightning-chain) | 120 | 40th | |240 |

### Class Abilities

#### Lore Bonus

Warlocks gain 6 points of Lore at each level, rather than 3 points like other thief kits.

#### Unearthly Resilience

The warlock slowly starts regenerating his health at a rate of 1 hit point per round.

#### Energy Resistance

The warlock gains 20% energy resistance to acid, cold, electricity, or fire.

#### Fiendish Servant

The warlock gains the service of an imp, which he can summon once per day. 

### Invocation Descriptions

#### Eldritch Blast

**Level Equivalent:** 1-9

A warlock's basic attack—a surge of pure eldritch power. This ability deals 1d6 points of magical damage for every two warlock levels after first (to a maximum of 20d6 at 39th level) and is subject to magic resistance.

#### Devil's Sight

**Level Equivalent:** 1
**Duration:** 8 hours
**Recharge:** 1 hour

You gain the visual acuity of a devil, granting you infravision and a +20% bonus to Detect Illusions. While active, the warlock is also immune to the *darkness* spell.

#### Shadow Armor

**Level Equivalent:** 2
**Duration:** 8 hours
**Recharge:** 1 hour

You envelop yourself in shadows that deflect attacks as though they were studded leather armor (AC 7) and give you immunity to the magic missile spell. For every three levels after 2nd, the armor gains a +1 bonus, to a maximum of +5 at 17th level.

#### Brimstone Ray

**Level Equivalent:** 1-9
**Area of Effect:** 20-foot line
**Recharge:** 2 rounds

You change your eldritch blast into a fiery burst that incinerates your victims. Creatures struck by brimstone ray catch on fire and take an additional 2d6 points of fire damage on the following round if they fail a saving throw.

#### Walk Unseen

**Level Equivalent:** 2
**Duration:** 1 hour
**Recharge:** 1 minute

You gain the ability to fade from view. You are invisible for the duration of the effect or until you engage in combat.

#### Hellrime Breath

**Level Equivalent:** 1-9
**Area of Effect:** 15-foot cone
**Recharge:** 4 rounds

You change your eldritch blast into a breath of chilling cold that deals cold damage to all creatures in the area of effect and reduces their Dexterity for 2 rounds. Affected creatures get a saving throw for half damage.

#### A Cold Day in Hell

**Level Equivalent:** 4
**Duration:** 1 hour
**Recharge:** 1 hour

You manifest the extremes of hellish domains, gaining either a +50% resistance to cold and a -50% resistance to fire or a +50% resistance to fire and a -50% resistance to cold.

#### Enthrall

**Level Equivalent:** 5
**Duration:** 8 rounds
**Recharge:** 1 minute

You enthrall a creature's mind, allowing you to control their actions while the invocation is in effect. Regardless of whether the creature makes a successful saving throw or not, it can not be affected again by this ability for 24 hours.

### Custom Script

The warlock kit comes with a custom script (`WARLOCK0`) which can be set for any warlock character through the customize menu on the character screen.

A warlock using this script will automatically use Devil's Sight and Shadow Armor if the invocations are not currently active.

By default, a warlock will be aggressive in combat, using his offensive invocations, alternating between Brimstone Ray and Eldritch Blast unless the enemies' resistances are too high. He will attempt to use his abilities as safely as possible, though he might still hit some of his allies if the positioning changes significantly after he begins invoking his powers.

If enemies are within weapon range, the warlock will also attack with his weapon between invocations to make full use of his combat actions.

If switched to defensive mode, the warlock will use Detect Illusions when possible. He will defend himself if attacked and if the enemy is in range, otherwise he will withdraw to a safer distance. Use this mode if you find that the warlock is causing too much collateral damage with his invocations and would like to control him manually instead.

By switching stealth mode on, the warlock will use his Walk Unseen invocation (if available) as long as he is not currently engaged in combat.

#### HotKeys

- `D`: Switch Defensive mode on or off.
- `S`: Switch Stealth mode on or off.

## Component: Recruitable NPC

### Information

| Trait         | Info               |
| ------------- | ------------------ |
| **Gender**    | Male               |
| **Race**      | Human              |
| **Class**     | Warlock            |
| **Alignment** | Lawful Evil        |
| **Area**      | Ulcaster (topside) |

### Starting Abilities

| Ability          | Score |
| ---------------- | :---: |
| **Strength**     | 13    |
| **Dexterity**    | 16    |
| **Constitution** | 8     |
| **Intelligence** | 13    |
| **Wisdom**       | 12    |
| **Charisma**     | 17    |

## Component: Shadow Walking

Once Ayden has recovered some of his lost power, he will offer to transport the party to previously visited areas through the Plane of Shadow. This ability is provided as a simple convenience to reduce unnecessary traveling time and will be unavailable during parts of the game where the player would otherwise not be able to leave the current area. In certain cases, it may provide an alternative means of escaping (such as when the player is thrown in jail).

## Component: Random Encounters

Shadow walking also comes with an optional random encounters component which will impose a small chance of encountering 
hostile creatures while traveling through the Plane of Shadow.

## Component: Ayden's Refuge

This component adds a new area where the party can shadow walk to once Ayden regains his powers. Ayden's Refuge is a small pocket plane created by the warlock before being imprisoned and serves as a safe place to rest and store items.

> *Note: As with shadow walking, this optional component serves merely as a convenience and adds little narrative value overall. If it doesn't suit your play style, you do not need to worry about missing out on anything major.*

## Component: Item Crafting

This component enables item crafting via the forge inside Ayden's Refuge. In order to craft items, Ayden must have recovered a sufficient portion of his power. After that, you can interact with the forge to view crafting recipes and craft items.

Some additional items have also been added to various vendors across the Sword Coast in order to more easily facilitate the crafting process. These mostly include mundane crafting components that would otherwise be hard to obtain (but should not be).

> *Note: This component is optional. If it doesn't suit your play style or you feel it adversely affects the balance of the game, you can skip it at installation (or ignore the forge in the Refuge).*

## Component: Wands for Thieves

This simple component will enable the use of wands for all thief kits (including warlocks) if they meet the ability requirements.

> *Note: This will change the usability flags for all wands (including modded ones) that are available at the time of installation.*

## Component: Thief Proficiencies

This component will change the configuration so that all thieves and thief kits can gain (at least) 1 point in spear or mace proficiency, like warlock. This should facilitate the use of light maces and certain spears.

> *Note: This will change the proficiency flags for all thief kits (including modded ones) that are available at the time of installation.*

## Known Issues

- There is currently no way to replace the useless buttons on the action bar.
- The level up screen will only show +3 lore gained due to engine limitations.
- Teleporting to areas could potentially fail to trigger certain story-related game scripts.
- Ayden seems to have rapidly aged several decades between different versions.
- Due to engine shenanigans, Energy Resistance is only granted if the party AI is turned on.
- Some crafting components may share the icon and/or name with an entirely invalid item.

## Compatibility

The mod might be incompatible with any mods that drastically change the game's file stucture and/or story flow (like BGT, etc.).

## Frequently Asked Questions

**Q: Is the mod EET-compatible or can we expect it to be in the future?**

A: To the best of my knowledge, no. It's an open issue with no set timeline.

**Q: Furret has left the area! Can I still recruit Ayden?**

A: Furret has decided to visit a nearby halfling town. You can find him there.

**Q: Ayden's skills have disappeared! How can I get them back?**

A: That is a side effect of skill cooldown. They will reappear in due time.

**Q: Ayden keeps hitting my party members with his Brimstone Blast. What can I do?**

A: Switch him to defensive mode and use his abilities manually.

**Q: I started a new game in Siege of Dragonspear. Can I recruit Ayden somewhere?**

A: Currently, not without using the console. This might change in future versions.

**Q: I accidentally gave the mimic an item I needed and now it's gone. What do I do?**

A: Your items can be retrieved with the console. Consult one of the forum threads for instructions.

## Special Thanks

Special thanks to Westley Weimer, Valerio Bigiani (The Bigg), and Fredrik Lindgren (Wisp) for creating and updating WeiDU.

Eternal glory to Avenger for giving us DLTCEP. Many of this mod's game files were created with the help of his editor.

Salutations to John Olav Hauglid and the rest of the team for their work on Near Infinity. We'd be lost without it.

Thanks to Razfallow for his Teleport mod and for allowing me to make use of it as part of this project.

A very special thanks to all my beta testers for helping me keep this mod bug-free and balanced.

A huge thank you to Skye for helping with the research and a lot of the legwork.

## Copyright Notice

All original materials in this mod are &copy; Keneth O'Connor. Please contact me if you wish to make use of anything.

WeiDU is released under GPL. The latest version of WeiDU can be downloaded [here](https://github.com/WeiDUorg/weidu/releases).

Several original (unmodified) BAM icons were extracted from Icewind Dale 2 and are a copyright of Atari.

Additional (unmodified) BAM icons were extracted from Planescape: Torment &mdash; Enhanced Edition and are a copyright of Beamdog.

The warlock class concept, as well as the City of Shade source material, are a copyright of Wizards of the Coast.

Some of the map assets were copied from Pillars of Eternity and are a copyright of Obsidian Entertainment.

Additional map assets were created by [Kenney.nl](https://kenney.nl) for the public domain.

The Baelnorn portrait was painted by Anastasya Zakharova. You can find her art over at [nodens.artstation.com](https://nodens.artstation.com).

Maagras' portrait was painted by Maria Zolotukhina. You can find her art over at [atenebris.deviantart.com](https://atenebris.deviantart.com").

Melgann's portrait was painted by Ognjen Sporin. You can find his art over at [ognyendyolic.artstation.com](https://ognyendyolic.artstation.com").

You do NOT have permission to share this mod or any of its files on any hosting sites without consulting the author.

## Version History

### Upcoming Features

- General improvements.
- New quest for Siege of Dragonspear.
- Additional content and improvements for SoD.
- New encounters on the Plane of Shadow.
- Additional crafting recipes.
- Invocation selection screen.
- Character voice-over.

### Version 2.6 (2022-01-13)
- Added new curse eater abilities for SoD items.
- Revamped Ayden's Refuge:
  - Parts of the refuge will now unlock dynamically.
  - Chests and Forge will now unlock with short tasks.
  - Added a teleportation circle.
  - Added the brewing cauldron feature.
  - Added the astral mimic feature.
  - Added the infernal banker feature.
- Fleshed out Ayden's warlock patron.
- Added altercation with Dradeel.
- Added option to delay most major conversations.
- Improved global transfer for BG2 imports.
- Fixed teleport animation for Ayden leaving.
- Replace proprietary Refuge background with a generated one.
- Added fog to Ayden's refuge to animate the environment.
- Added a gem merchant that will occasionally visit the Refuge.
- Completely recreated all project documentation.
- Created new areas and creatures for random encounters in Shadowfell.
- Added the option of a more peaceful interaction with the Dark Moon temple.
- Fully integrated random encounters into shadow walking.

### Version 2.5 (2021-09-10)

- Added recharge values to invocations for balance.
- Added status icons for Curse Eater abilities.
- Moved Curse Eater animations to script actions.
- Increased Aura of Thorns range to 100.
- Furret will move to Gullykin instead of disappearing.
- Siege of Dragonspear compatibility fixes.
- Additional content for Siege of Dragonspear.
- Added forge to Ayden's Refuge.
- Added the ability to craft items in the forge.
- Removed the overly complicated conversation points system.
- Adjusted Ayden's leveling script to be consistent with EE companions.
- Added new conversations and conversation topics with Ayden.
- Added a number of new interjections from Ayden.
- Added short banters between Ayden and other companions.
- Warlock script should no longer cast brimstone ray at a group of allies.
- Added a map marker for Ayden's prison in Ulcaster.
- Remapped warlock script's defensive mode to the D key.
- Ayden can now teleport the party back to where they were from the Refuge.
- The game will auto-save before teleporting to any location.
- Added ability/invocation description icons.
- Added a new quest to advance Ayden's storyline.
- Added potentially missing items for the forge.
- Added new spells and spell scrolls required for crafting.
- Added new crafting components.
- Converted several BAM graphics to v2 and a texture atlas (MOS).
- Fixed issues with certain quests and dialogues.
- Extended documentation with FAQ and item crafting recipes.
- Add new crafting components to SoD stores.
- Return Ayden to camp in Siege of Dragonspear.
- Move Ayden out of the bedroom at the start of Siege of Dragonspear.
- Ayden leaves party during Siege of Dragonspear epilogue.
- Update bag of holding to support all non-bag item types.
- Fix spears for thieves component to include SoD spears.
- Block shadow walking in the final chapters of SoD.

### Version 2.4b31 (2017-05-14)

- Fixed issues with the player script.
- Fixed a bug in the autoleveling portion of Ayden's script.
- Fixed a bug with dialog variables not setting correctly.
- Fixed a bug with Ayden's dialogue timers.
- Fixed an issue with dialog transitions.
- Fixed an issue with delayed conversations.
- Fixed a bug with Ayden's shapeshifter talk.
- Fixed broken dialogue in Ayden's Refuge.
- Fixed an issue with missing area scripts.
- Removed redudant Colquetle family spawn in AR4300.
- Improved the portrait to better fit in with existing ones.
- Ayden will no longer chat while in combat.
- Updated WeiDU to v240 to fix journal issues.
- Improved Shadow Armor graphics and balance.
- Reduced the volume of shadow walking animations.
- Fixed mismatched target areas when shadow walking.
- Fixed issues with the imp's abilities that caused a crash.
- Fixed an issue with Warlock weapon profficiencies.
- Created new icons for Ayden's curse eater abilities.
- Made spears useable by thieves (including Warlocks).
- Fiendish servant will now defend itself if attacked.
- Added Armor of Missile Attraction to the game.
- Flipped a story flag upon return to the Isle of Balduran.
- Fixed a bug where Shadow Walking would not reset properly.
- Fixed script names for Furret and Keeper of the Portal.

### Version 2.4 BETA (2017-04-09)

- Script and dialogue fixes.
- Created Ayden's Refuge.
- Alternative portrait.

### Version 2.3 BETA (2017-03-26)

- Updated the mod to work with the new engine.
- Restored Brimstone Blast to Brimstone Ray.
- Added "Wands for Thieves" optional component.
- Slightly altered proficiencies.
- Disabled dual-classing for warlock.
- Improved a few ability icons.
- Added energy resistance.
- Made preparations for BG2:EE.
- Changed the concept of the kit somewhat.
- Added light maces usable by rogues.
- Added a bunch of conversations with Ayden.
- Implemented Shadow Walking (teleportation).
- Added missing abilities for Imps

### Version 2.2 BETA (2015-09-23)

- Added a joinable NPC.
- Added a new quest.
- Added two new magic items.
- Added a custom-painted portrait.
- Added some conversation.
- Added the Curse Eater ability.

### Version 2.1 BETA (2015-09-16)

- Made invocations detectable via script.
- Changed Brimstone Ray into Brimstone Blast for the time being.
- Added ability to use invocations when silenced.
- Replaced Walk Unseen icon with something more appropriate.
- Changed the ordering of abilities for a smoother progression.
- Added A Cold Day in Hell invocation at tenth level.
- Added short descriptions for invocations in-game.
- Created a custom script for warlock characters.

### Version 2.0b13 BETA (2014-01-01)

- Changed a few icons.
- Extended Devil's Sight to 8 hours.
- Decreased the imp's AC to account for Dex bonus.
- Switched Entropic Warding for Shadow Armor.

### Version 2.0b9 BETA (2013-12-31)

- Added Unearthly Resilience.
- Improved ability icon graphics.
- Altered invocation casting times.
- Changed the dynamics of Brimstone Ray.
- Added Fiendish Servant.
- Switched Crawling Eye for Entropic Warding.
- Fixed invocation stacking.
- Expanded WILDMAG.2DA to avoid blank "Wild Surge: " strings.
- Added Detect Good to Fiendish Servant.

### Version 2.0 BETA (2013-12-27)

- Recreated the kit from scratch for BG:EE. Only includes files for levels 1-10.

### Version 1.26 BETA (2007-06-21)

- The last functioning version for Baldur's Gate 2: Throne of Bhaal.
